Summary: Wrapper package to trigger installation of the Virtualmin Stack 
Name: virtualmin-base
Version: 1.0
Release: 65.rh
Group: System Environment/Base
License: Copyright 2005-2013 Virtualmin, Inc.
Packager: Joe Cooper <joe@virtualmin.com>
Distribution: Virtualmin Stack
Vendor: Virtualmin, Inc.
BuildRoot: /tmp/%{name}-%{version}
BuildArch: noarch
Requires: webmin >= 1.630 usermin >= 1.550 wbm-virtual-server perl(Net::SSLeay) perl(IO::Tty) proftpd wbt-virtual-server-theme wbt-virtual-server-mobile logrotate wbm-virtualmin-dav wbm-virtualmin-svn wbm-virtualmin-awstats wbm-virtualmin-mailman wbm-virtualmin-htpasswd wbm-virtualmin-registrar awstats clamav /usr/sbin/clamd /usr/bin/freshclam mod_fcgid scponly httpd mod_ssl /usr/bin/mysqladmin cyrus-sasl cyrus-sasl-gssapi cyrus-sasl-md5 cyrus-sasl-plain mod_dav_svn ust-virtual-server-theme procmail-wrapper wbm-php-pear wbm-security-updates wbm-ruby-gems wbm-virtualmin-init unzip bzip2 wbm-virtualmin-git wbm-virtualmin-sqlite 

%description
This wrapper depends on almost everything in the Virtualmin Stack.  It is 
installed by install.sh, which executes the setup scripts to preconfigure all 
services.

This package does not include the serial number.  When installed using yum or 
another dependency-aware utility, everything gets installed automatically.
Hooray for yum!

%prep
mkdir -p %{buildroot}

%build

%install
mkdir -p $RPM_BUILD_ROOT/usr/bin

%files

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /usr/bin/perl
# Check for fresh install, if it's not, we skip the configuration step
$install_p = $ARGV[0];
# Setup Webmin environment
$no_acl_check++;
$ENV{'WEBMIN_CONFIG'} ||= "/etc/webmin";
$ENV{'WEBMIN_VAR'} ||= "/var/webmin";
$ENV{'MINISERV_CONFIG'} = $ENV{'WEBMIN_CONFIG'}."/miniserv.conf";
$trust_unknown_referers = 1;
open(CONF, "$ENV{'WEBMIN_CONFIG'}/miniserv.conf") || die "Failed to open miniserv.conf";
while(<CONF>) {
	if (/^root=(.*)/) {
		$root = $1;
		}
	}
close(CONF);
$root ||= "/usr/libexec/webmin";
chdir($root);
$0 = "$root/virtualmin_base.pl";
require './web-lib.pl';
init_config();

if ( $install_p == "1" ) {
	$main::error_must_die = 1;
	# Set the Webmin theme
	eval { # try
	print "Setting Webmin theme\n";
	foreign_require("webmin", "webmin-lib.pl");
	$gconfig{'theme'} = "virtual-server-theme";
	$gconfig{'logfiles'} = 1;
	write_file("$config_directory/config", \%gconfig);
	get_miniserv_config(\%miniserv);
	$miniserv{'preroot'} = "virtual-server-theme";
	$miniserv{'ssl'} = 1;
	$miniserv{'ssl_cipher_list'} = $webmin::strong_ssl_ciphers;
	put_miniserv_config(\%miniserv);
	restart_miniserv();
	1;
	} 
	or do { # catch
		print "Error occurred while setting Webmin theme: $@\n";
	};

	# Set the Usermin theme
	eval {
	print "Setting Usermin theme\n";
	foreign_require("usermin", "usermin-lib.pl");
	usermin::get_usermin_config(\%uconfig);
	$uconfig{'theme'} = "virtual-server-theme";
	$uconfig{'gotomodule'} = 'mailbox';
	usermin::put_usermin_config(\%uconfig);
	usermin::get_usermin_miniserv_config(\%uminiserv);
	$uminiserv{'preroot'} = "virtual-server-theme";
	$uminiserv{'ssl'} = "1";
	$uminiserv{'ssl_cipher_list'} = $webmin::strong_ssl_ciphers;
	$uminiserv{'domainuser'} = 1;
	$uminiserv{'domainstrip'} = 1;
	usermin::put_usermin_miniserv_config(\%uminiserv);
	usermin::restart_usermin_miniserv();
	1;
	}
	or do {
		print "Error occurred while setting Usermin theme: $@\n";
	};

	# Configure virtual maps in Postfix
	eval {
	print "Configuring Postfix\n";
	foreign_require("postfix", "postfix-lib.pl");
	if (!postfix::get_real_value("virtual_alias_maps")) {
		postfix::set_current_value("virtual_alias_maps",
					    "hash:/etc/postfix/virtual", 1);
		}
	postfix::ensure_map($postfix::virtual_maps);
	postfix::regenerate_virtual_table();

	# Setup BCC map
	if (!postfix::get_real_value("sender_bcc_maps")) {
		postfix::set_current_value("sender_bcc_maps",
					    "hash:/etc/postfix/bcc");
		}
	postfix::ensure_map("sender_bcc_maps");
	postfix::regenerate_bcc_table()
		if (defined(postfix::regenerate_bcc_table));

	# Setup sender dependent map
	if ($postfix::postfix_version >= 2.7) {
		if (!postfix::get_real_value(
		     	"sender_dependent_default_transport_maps")) {
			postfix::set_current_value(
				"sender_dependent_default_transport_maps",
				"$maptype:$postetc/dependent");
			}
		postfix::ensure_map("sender_dependent_default_transport_maps");
		postfix::regenerate_any_table(
			"sender_dependent_default_transport_maps");
		}

	postfix::set_current_value("mailbox_command",
		"/usr/bin/procmail-wrapper -o -a \$DOMAIN -d \$LOGNAME", 1);
	postfix::set_current_value("home_mailbox", "Maildir/", 1);
	postfix::set_current_value("inet_interfaces", "all", 1);
	# smtpd -o smtpd_sasl_auth_enable=yes
	# Add smtp auth stuff to main.cf
	postfix::set_current_value("smtpd_sasl_auth_enable", "yes", 1);
	postfix::set_current_value("smtpd_sasl_security_options", "noanonymous", 1);
	postfix::set_current_value("broken_sasl_auth_clients", "yes", 1);
	postfix::set_current_value("smtpd_recipient_restrictions", "permit_mynetworks permit_sasl_authenticated reject_unauth_destination", 1);
	$mydest = postfix::get_current_value("mydestination");
	$myhost = get_system_hostname();
	if ($mydest !~ /\Q$myhost\E/) {
		postfix::set_current_value("mydestination",
					    $mydest.", ".$myhost, 1);
		}

	# Turn off limit on mailbox size
	postfix::set_current_value("mailbox_size_limit", "0");

	# Turn off % hack, which breaks user%domain mailboxes
	postfix::set_current_value("allow_percent_hack", "no");

	# And master.cf
	$master = postfix::get_master_config();
	($smtp) = grep { $_->{'name'} eq 'smtp' && $_->{'enabled'} } @$master;
	$smtp || die "Failed to find SMTP postfix service!";
	if ($smtp->{'command'} !~ /smtpd_sasl_auth_enable/) {
	  $smtp->{'command'} .= " -o smtpd_sasl_auth_enable=yes";
	  postfix::modify_master($smtp);
	  }

	# Add submission entry, if missing
	($submission) = grep { $_->{'name'} eq 'submission' && $_->{'enabled'} } @$master;
	if (!$submission) {
		$submission = { %$smtp };
		$submission->{'name'} = 'submission';
		postfix::create_master($submission);
		}

	delete($main::file_cache{$postfix::config{'postfix_config_file'}});
	postfix::reload_postfix();

	# Make sure other code knows the Postfix version
	$postfix::postfix_version =
		backquote_command("$postfix::config{'postfix_config_command'} -h mail_version");
	$postfix::postfix_version =~ s/\r|\n//g;
	open_tempfile(VER, ">$postfix::module_config_directory/version");
	print_tempfile(VER, $postfix::postfix_version,"\n");
	close_tempfile(VER);

        # Force alias map rebuild if missing
        &postfix::regenerate_aliases();
	1;
	}
	or do {
		print "Error occurred while configuring Postfix: $@\n";
	};

	# Make sure Postfix is started at boot, and sendmail isn't
	eval {
	print "Enabling Postfix and disabling Sendmail\n";
	foreign_require("init", "init-lib.pl");
	system("/usr/sbin/alternatives --set mta /usr/sbin/sendmail.postfix");
	init::enable_at_boot("postfix");
	init::disable_at_boot("sendmail");
	if (init::action_status("clamd-wrapper")) {
		init::enable_at_boot("clamd-wrapper");
		}
	foreign_require("sendmail", "sendmail-lib.pl");
	if (sendmail::is_sendmail_running()) {
		sendmail::stop_sendmail();
		}
	system("killall -9 sendmail >/dev/null 2>&1");
	system("newaliases");
	if (!postfix::is_postfix_running()) {
		$err = postfix::start_postfix();
		print STDERR "Failed to start Postfix!\n" if ($err);
		}
	1;
	}
	or do {
		print "Error occurred while enabling Postfix and disabling Sendmail: $@\n";
	};

	# Make sure freshclam is not disabled
	eval {
	print "Setting up freshclam\n";
	$fcconf = "/etc/sysconfig/freshclam";
	if (-r $fcconf) {
		my $lref = read_file_lines($fcconf);
		foreach my $l (@$lref) {
			if ($l =~ /^FRESHCLAM_DELAY=disabled/) {
				$l = "#$l";
				}
			}
		flush_file_lines($fcconf);
		}

	# Remove Example line from config
	$freshconf = "/etc/freshclam.conf";
	if (-r $freshconf) {
		my $lref = read_file_lines($freshconf);
		foreach my $l (@$lref) {
			if ($l =~ /^Example/) {
				$l = "#Example";
				}
			}
		flush_file_lines($freshconf);
		}

	# Run freshclam once, to download ClamAV database
	system("freshclam || :");
	1;
	}
	or do {
		print "Error occurred while setting up freshclam: $@\n";
	};

	# Dovecot POP3 and IMAP
	eval {
	print "Configuring Dovecot for POP3 and IMAP\n";
	foreign_require("dovecot", "dovecot-lib.pl");

	# Work out dirs for control and index files
	foreign_require("mount", "mount-lib.pl");
	$indexes = "";
	($homedir) = mount::filesystem_for_dir("/home");
	($vardir) = mount::filesystem_for_dir("/var");
	if ($homedir ne $vardir) {
		if (!-d "/var/lib") {
			make_dir("/var/lib", 0755);
			}
		if (!-d "/var/lib/dovecot-virtualmin") {
			make_dir("/var/lib/dovecot-virtualmin", 0755);
			}
		make_dir("/var/lib/dovecot-virtualmin/index", 0777);
		make_dir("/var/lib/dovecot-virtualmin/control", 0777);
		$indexes = ":INDEX=/var/lib/dovecot-virtualmin/index/%u".
			   ":CONTROL=/var/lib/dovecot-virtualmin/control/%u";
		}

	$conf = dovecot::get_config();
	if (&dovecot::get_dovecot_version() >= 2) {
		&dovecot::save_directive($conf, "protocols",
					 "imap pop3");
		}
	else {
		&dovecot::save_directive($conf, "protocols",
					 "imap imaps pop3 pop3s");
		}
	if (dovecot::find("mail_location", $conf, 2)) {
		dovecot::save_directive($conf, "mail_location",
					 "maildir:~/Maildir".$indexes);
		}
	else {
		dovecot::save_directive($conf, "default_mail_env",
					 "maildir:~/Maildir".$indexes);
		}
	if (dovecot::find("pop3_uidl_format", $conf, 2)) {
		dovecot::save_directive($conf, "pop3_uidl_format",
					 "%08Xu%08Xv");
		}
	elsif (dovecot::find("pop3_uidl_format", $conf, 2, "pop3")) {
		dovecot::save_directive($conf, "pop3_uidl_format",
					 "%08Xu%08Xv", "pop3");
		}
	&dovecot::save_directive($conf, "disable_plaintext_auth", "no");
	$am = &dovecot::find_value("auth_mechanisms", $conf, 2);
	if ($am && $am !~ /login/) {
		$am .= " login";
		&dovecot::save_directive($conf, "auth_mechanisms", $am);
		}
	flush_file_lines();
	print "Enabling Dovecot POP3 and IMAP servers\n";
	init::enable_at_boot("dovecot");
	if (!dovecot::is_dovecot_running()) {
	  $err = dovecot::start_dovecot();
	  print STDERR "Failed to start Dovecot POP3/IMAP server!\n" if ($err);
	  }
	1;
	}
	or do {
		print "Error occurred while configuring or enabling Dovecot: $@\n";
	};

	# ProFTPd
	eval {
	print "Enabling ProFTPd\n";
	init::enable_at_boot("proftpd");
	$cmd = "/etc/init.d/proftpd start";
	foreign_require("proc", "proc-lib.pl");
	proc::safe_process_exec($cmd, 0, 0, STDOUT, undef, 1);
	1;
	}
	or do {
		print "Error occurred while enabling ProFTPd: $@\n";
	};

	# SASL SMTP authentication
	eval {
	print "Enabling SMTP authentication\n";
  system("echo 'pwcheck_method: saslauthd' > /usr/lib/sasl2/smtpd.conf");
  system("echo 'mech_list: PLAIN LOGIN' >> /usr/lib/sasl2/smtpd.conf");
	if ( -d "/usr/lib64/sasl2" ) {
  	system("echo 'pwcheck_method: saslauthd' > /usr/lib64/sasl2/smtpd.conf");
  	system("echo 'mech_list: PLAIN LOGIN' >> /usr/lib64/sasl2/smtpd.conf");
	}
	local $saslconfig = "/etc/sysconfig/saslauthd";
	if (-r $saslconfig) {
		local $lref = &read_file_lines($saslconfig);
		foreach my $l (@$lref) {
			if ($l =~ /^\s*FLAGS=\s*$/) {
				$l = "FLAGS=\"-r\"";
				}
			}
		&flush_file_lines($saslconfig);
		}
	init::enable_at_boot("saslauthd");
	$cmd = "/etc/init.d/saslauthd start";
	proc::safe_process_exec($cmd, 0, 0, STDOUT, undef, 1);
	1;
	}
	or do {
		print "Error occurred while enabling SMTP authentication: $@\n";
	};

	# Tell Virtualmin to use Postfix, and enable all features
	eval {
	print "Configuring Virtualmin\n";
	%vconfig = foreign_config("virtual-server");
	$vconfig{'mail_system'} = 0;
	$vconfig{'aliascopy'} = 1;
	$vconfig{'home_base'} = "/home";
	$vconfig{'spam'} = 1;
	$vconfig{'virus'} = 1;
	$vconfig{'ssl'} = 2;
	$vconfig{'ftp'} = 2;
	$vconfig{'postgresql'} = 1;
	$vconfig{'logrotate'} = 3;
	$vconfig{'default_procmail'} = 1;
	$vconfig{'bind_spfall'} = 0;
	$vconfig{'bind_spf'} = "yes";
	$vconfig{'spam_delivery'} = "\$HOME/Maildir/.spam/";
	$vconfig{'bccs'} = 1;
	if (!defined($vconfig{'plugins'})) {
		$vconfig{'plugins'} = 'virtualmin-dav virtualmin-awstats virtualmin-mailman virtualmin-htpasswd';
		}

	# Make the Virtualmin web directories a bit more secure
	$vconfig{'web_user'} = "apache";
	$vconfig{'html_perms'} = "0750";
	$vconfig{'php_suexec'} = 2;
	save_module_config(\%vconfig, "virtual-server");

	# Configure the Read User Mail module to look for sub-folders
	# under ~/Maildir , and to use Postfix
	%mconfig = foreign_config("mailboxes");
	$mconfig{'mail_usermin'} = "Maildir";
	$mconfig{'from_virtualmin'} = 1;
	$mconfig{'mail_system'} = 0;
	save_module_config(\%mconfig, "mailboxes");

	# Setup the Usermin read mail module
	$cfile = "$usermin::config{'usermin_dir'}/mailbox/config";
	read_file($cfile, \%mailconfig);
	($map) = postfix::get_maps_files(&postfix::get_real_value(
			$postfix::virtual_maps));
	$map ||= "/etc/postfix/virtual";
	$mailconfig{'from_map'} = $map;
	$mailconfig{'from_format'} = 1;
	$mailconfig{'mail_system'} = 4;
	$mailconfig{'pop3_server'} = 'localhost';
	$mailconfig{'mail_qmail'} = undef;
	$mailconfig{'mail_dir_qmail'} = 'Maildir';
	$mailconfig{'server_attach'} = 0;
	$mailconfig{'send_mode'} = 'localhost';
	$mailconfig{'nologout'} = 1;
        $mailconfig{'noindex_hostname'} = 1;
	write_file($cfile, \%mailconfig);

	# Set the mail folders subdir to Maildir
	$ucfile = "$usermin::config{'usermin_dir'}/mailbox/uconfig";
	read_file($ucfile, \%umailconfig);
	$umailconfig{'mailbox_dir'} = 'Maildir';
	write_file($ucfile, \%umailconfig);

	# Set the default Usermin ACL to only allow access to email modules
	usermin::save_usermin_acl("user",
		[ "mailbox", "changepass", "spam", "filter" ]);

	# Lock down the Usermin file manager and browser to users' homes
	$cfile = "$usermin::config{'usermin_dir'}/file/config";
	read_file($cfile, \%fileconfig);
	$fileconfig{'home_only'} = 1;
	write_file($cfile, \%fileconfig);
	$afile = "$usermin::config{'usermin_dir'}/user.acl";
	read_file($afile, \%uacl);
	$uacl{'root'} = '';
	write_file($afile, \%uacl);

	# Configure the Usermin Change Password module to use Virtualmin's
	# change-password.pl script
	$cfile = "$usermin::config{'usermin_dir'}/changepass/config";
	read_file($cfile, \%cpconfig);
	$cpconfig{'passwd_cmd'} =
		"$root_directory/virtual-server/change-password.pl";
	$cpconfig{'cmd_mode'} = 1;
	write_file($cfile, \%cpconfig);

	# Also do the same thing for expired password changes
	$cfile = "$usermin::config{'usermin_dir'}/config";
	&read_file($cfile, \%umconfig);
	$umconfig{'passwd_cmd'} =
		"$root_directory/virtual-server/change-password.pl";
	&write_file($cfile, \%umconfig);

	# Setup the Apache, BIND and DB modules to use tables for lists
	foreach my $t ([ 'apache', 'show_list' ],
		      [ 'bind8', 'show_list' ],
		      [ 'mysql', 'style' ],
		      [ 'postgresql', 'style' ]) {
		my %mconfig = foreign_config($t->[0]);
		$mconfig{$t->[1]} = 1;
		save_module_config(\%mconfig, $t->[0]);
		}

	# Configure the Software module to use YUM and RPMs
	my %sconfig = foreign_config('software');
	$sconfig{'package_system'} = 'rpm';
	$sconfig{'update_system'} = &has_command("yum") ? 'yum' :
				    &has_command("up2date") ? 'rhn' : undef;
	save_module_config(\%sconfig, 'software');

	# Make the default home directory permissions 750
	my %uconfig = &foreign_config("useradmin");
	$uconfig{'homedir_perms'} = "0750";
	save_module_config(\%uconfig, "useradmin");
	1;
	}
	or do {
		print "Error occurred while configuring Virtualmin: $@\n";
	};

	# Create a global Procmail rule to deliver to ~/Maildir/
	eval {
	print "Configuring Procmail\n";
	foreign_require("procmail", "procmail-lib.pl");
	my @recipes = procmail::get_procmailrc();
	foreach $r (@recipes) {
		if ($r->{'name'} eq "DEFAULT") {
			$defrec = $r;
			}
		elsif ($r->{'name'} eq "ORGMAIL") {
			$orgrec = $r;
			}
		}
	if ($defrec) {
		# Fix up this DEFAULT entry
		$defrec->{'value'} = '$HOME/Maildir/';
		procmail::modify_recipe($defrec);
		}
	else {
		# Prepend a DEFAULT entry
		$defrec = { 'name' => 'DEFAULT',
			    'value' => '$HOME/Maildir/' };
		if (@recipes) {
			procmail::create_recipe_before($defrec, $recipes[0]);
			}
		else {
			procmail::create_recipe($defrec);
			}
		}
	if ($orgrec) {
		# Fix up this ORGMAIL entry
		$orgrec->{'value'} = '$HOME/Maildir/';
		procmail::modify_recipe($orgrec);
		}
	else {
		# Prepend a ORGMAIL entry
		$orgrec = { 'name' => 'ORGMAIL',
			    'value' => '$HOME/Maildir/' };
		if (@recipes) {
			procmail::create_recipe_before($orgrec, $recipes[0]);
			}
		else {
			procmail::create_recipe($orgrec);
			}
		}
	1;
	}
	or do {
		print "Error occurred while configuring Procmail: $@\n";
	};

	# Fix bad paths in Webalizer configuration
	eval {
	print "Configuring Webalizer\n";
	foreign_require("webalizer", "webalizer-lib.pl");
	$conf = webalizer::get_config();
	webalizer::save_directive($conf, "IncrementalName", "webalizer.current");
	webalizer::save_directive($conf, "HistoryName", "webalizer.hist");
	webalizer::save_directive($conf, "DNSCache", "dns_cache.db");
	flush_file_lines($webalizer::config{'webalizer_conf'});
	1;
	}
	or do {
		print "Error occurred while configuring Webalizer: $@\n";
	};

	# Add /bin/false to the shells file, for use by Virtualmin
	eval {
	print "Updating /etc/shells\n";
	$lref = read_file_lines("/etc/shells");
	$idx = indexof("/bin/false", @$lref);
	if ($idx < 0) {
		push(@$lref, "/bin/false");
		push(@$lref, "/usr/bin/scponly");
		flush_file_lines("/etc/shells");
		}
	1;
	}
	or do {
		print "Error occurred while updating /etc/shells: $@\n";
	};

	# Enable MySQL and PostgreSQL at boot time, and perform any initial setup
	eval {
	print "Enabling MySQL and PostgreSQL\n";
	init::enable_at_boot("mysqld");
	init::enable_at_boot("postgresql");
	foreign_require("mysql", "mysql-lib.pl");
	if (&mysql::is_mysql_running()) {
		&mysql::stop_mysql();
	}
	$conf = &mysql::get_mysql_config();
	($sect) = grep { $_->{'name'} eq 'mysqld' } @$conf;
	if ($sect) {
		&mysql::save_directive($conf, $sect,
			"innodb_file_per_table", [ 1 ]);
		&flush_file_lines($sect->{'file'});
		}
	$err = &mysql::start_mysql();
	print STDERR "Failed to start MySQL!\n" if ($err);
	foreign_require("postgresql", "postgresql-lib.pl");
	if (!-r $postgresql::config{'hba_conf'}) {
		# Needs to be initialized
		$err = postgresql::setup_postgresql();
		print STDERR "Failed to setup PostgreSQL!\n" if ($err);
		}
	if (postgresql::is_postgresql_running() == 0) {
		$err = postgresql::start_postgresql();
		print STDERR "Failed to start PostgreSQL!\n" if ($err);
		}
	1;
	}
	or do {
		print "Error occurred while enabling MySQL and PostgreSQL: $@\n";
	};

	# Enable Apache at boot time, and start now
	eval {
	print "Enabling Apache\n";
	init::enable_at_boot("httpd");
	foreign_require("apache", "apache-lib.pl");

	# Comment out config files that conflict
	foreach my $file ("/etc/httpd/conf.d/welcome.conf",
		          "/etc/httpd/conf.d/awstats.conf") {
		next if (!-r $file);
		my $lref = &read_file_lines($file);
		foreach my $l (@$lref) {
			if ($l !~ /^\s*#/) {
				$l = "#".$l;
				}
			}
		&flush_file_lines($file);
		}

	# Disable global UserDir option
	$conf = &apache::get_config();
	($userdir) = &apache::find_directive_struct("UserDir", $conf);
	if ($userdir) {
		&apache::save_directive("UserDir", [ ], $conf, $conf);
		&flush_file_lines($userdir->{'file'});
		}

        # Force use of PCI-compliant SSL ciphers
	foreign_require("webmin", "webmin-lib.pl");
        &apache::save_directive("SSLProtocol",
                [ "ALL -SSLv2" ], $conf, $conf);
        &apache::save_directive("SSLCipherSuite",
                [ $webmin::strong_ssl_ciphers ||
		  "HIGH:!SSLv2:!ADH:!aNULL:!eNULL:!NULL" ], $conf, $conf);
 
        # Turn off server signatures, which aren't PCI compliant
        &apache::save_directive("ServerTokens", [ "Minimal" ], $conf, $conf);
        &apache::save_directive("ServerSignature", [ "Off" ], $conf, $conf);
        &apache::save_directive("TraceEnable", [ "Off" ], $conf, $conf);
	&flush_file_lines();

	if (!apache::is_apache_running()) {
		$err = apache::start_apache();
		print STDERR "Failed to start Apache!\n" if ($err);
		}

	# Force re-check of installed Apache modules
	unlink($apache::site_file);
	1;
	}
	or do {
		print "Error occurred while enabling Apache: $@\n";
	};

	# Enable BIND at boot time, start it now, and setup initial config file
	eval {
	print "Configuring and enabling BIND\n";
	init::enable_at_boot("named");
	foreign_require("bind8", "bind8-lib.pl");
	$conffile = bind8::make_chroot($bind8::config{'named_conf'});
	if (!-r $conffile) {
		$bind8::config{'named_conf'} =~ /^(\S+)\/([^\/]+)$/;
		$conf_directory = $1;
		$pid_file = $bind8::config{'pid_file'} || "/var/run/named.pid";

		# Make sure all directories used by BIND exist
		$chroot = bind8::get_chroot();
		if ($chroot && !-d $chroot) {
			mkdir($chroot, 0755);
			}
		if (!-d bind8::make_chroot($conf_directory)) {
			mkdir(bind8::make_chroot($conf_directory), 0755);
			}
		if ($bind8::config{'master_dir'} &&
		    !-d bind8::make_chroot($bind8::config{'master_dir'})) {
			mkdir(bind8::make_chroot($bind8::config{'master_dir'}), 0755);
			}
		if ($bind8::config{'slave_dir'} &&
		    !-d bind8::make_chroot($bind8::config{'slave_dir'})) {
			mkdir(bind8::make_chroot($bind8::config{'slave_dir'}), 0777);
			}
		if ($pid_file =~ /^(.*)\//) {
			$pid_dir = $1;
			if (!-d bind8::make_chroot($pid_dir)) {
				mkdir(bind8::make_chroot($pid_dir), 0777);
				}
			}

		# Need to setup named.conf file, with root zone
		open(BOOT, ">$conffile");
		print BOOT "options {\n";
		print BOOT "    directory \"$conf_directory\";\n";
		print BOOT "    pid-file \"$pid_file\";\n";
		print BOOT "    allow-recursion { localnets; 127.0.0.1; };\n";
		print BOOT "    };\n";
		print BOOT "\n";
		print BOOT "zone \".\" {\n";
		print BOOT "    type hint;\n";
		print BOOT "    file \"$conf_directory/db.cache\";\n";
		print BOOT "    };\n";
		print BOOT "\n";
		close(BOOT);
		system("cp $root_directory/bind8/db.cache ".
		       bind8::make_chroot("$conf_directory/db.cache"));
		bind8::set_ownership(bind8::make_chroot("$conf_directory/db.cache"));
		bind8::set_ownership($conffile);
		}

	# On CentOS 6, BIND listens only on localhost by default
	undef(@bind8::get_config_cache);
	$conf = &bind8::get_config();
	$options = &bind8::find("options", $conf);
	if ($options) {
		&bind8::save_directive($options, "allow-query", [ ], 0);
		foreach my $dir ("listen-on", "listen-on-v6") {
			@listen = &bind8::find($dir, $options->{'members'});
			next if (!@listen);
			if ($listen[0]->{'values'}->[0] eq 'port' &&
			    $listen[0]->{'values'}->[1] eq '53' &&
			    $listen[0]->{'type'} &&
			    ($listen[0]->{'members'}->[0]->{'name'} eq
			     '127.0.0.1' ||
			     $listen[0]->{'members'}->[0]->{'name'} eq '::1')) {
				$listen[0]->{'members'}->[0]->{'name'} = 'any';
				}
			&bind8::save_directive($options, $dir, \@listen, 1);
			}
		&bind8::flush_file_lines();
		}

	if (!bind8::is_bind_running()) {
		bind8::start_bind();
		}
	else {
		bind8::restart_bind();
		}

	# Make sure the system is configured to use itself as a resolver
	if (foreign_check("net")) {
		print "Configuring resolv.conf to use local DNS server\n";
		foreign_require("net", "net-lib.pl");
		my $dns = net::get_dns_config();
		if (indexof("127.0.0.1", @{$dns->{'nameserver'}}) < 0) {
			unshift(@{$dns->{'nameserver'}}, "127.0.0.1");
			net::save_dns_config($dns);
			}
		}
	1;
	}
	or do {
		print "Error occurred while configuring and enabling BIND: $@\n";
	};

	# Enable Mailman qrunner on boot, and create 'mailman' list
	# Enable scheduled monitoring
	eval {
	if (foreign_installed("virtualmin-mailman")) {
		print "Configuring and enabling Mailman\n";
		foreign_require("virtualmin-mailman",
				 "virtualmin-mailman-lib.pl");
		my @lists = virtualmin_mailman::list_lists();
		my ($mlist) = grep { $_->{'list'} eq 'mailman' } @lists;
		if (!$mlist) {
			# Need to create
			$err = virtualmin_mailman::create_list(
				"mailman", undef,
				"Default mailing list",
				undef,
				"root\@".&get_system_hostname(),
				time().$$);
			if ($err) {
				$err =~ s/<pre>|<\/pre>//g;
				@lines = grep { /\S/ } split(/\n/, $err);
				$err = $lines[$#lines];
				print "List creation error : $err\n";
				}
			}
		init::enable_at_boot("mailman");
		if ($init::init_mode eq "init") {
			my $fn = init::action_filename("mailman");
			system("$fn start >/dev/null 2>&1 </dev/null");
			}
		}
	1;
	}
	or do {
		print "Error occurred while configuring and enabling up Mailman: $@\n";
	};

	# Enable scheduled monitoring
	eval {
	print "Enabling status monitoring\n";
	foreign_require("status", "status-lib.pl");
	$status::config{'sched_mode'} = 1;
	$status::config{'sched_int'} ||= 5;
	$status::config{'sched_offset'} ||= 0;
	&save_module_config(\%status::config, 'status');
	status::setup_cron_job();
	1;
	}
	or do {
		print "Error occurred while enabling status monitoring: $@\n";
	};

	# Hide the Upgrade Webmin page, as virtualmin package updates is better
	eval {
	print "Hiding the Webmin upgrade page\n";
	my %wacl = ( 'disallow' => 'upgrade' );
	save_module_acl(\%wacl, 'root', 'webmin');
	}
	or do {
		print "Error occurred hiding Webmin upgrade page: $@\n";
	};

	# Find the filesystem containing /home , and enable quotas on it
	eval {
	print STDERR "Enabling quotas on filesystem for /home\n";
	foreign_require("mount", "mount-lib.pl");
	mkdir("/home", 0755) if (!-d "/home");
	($dir, $dev, $type, $opts) = mount::filesystem_for_dir("/home");
	if (running_in_zone() || running_in_vserver()) {
		print STDERR "Skipping quotas for Vserver or Zones systems\n";
		return;
		}
	mount::parse_options($type, $opts);
	$mount::options{'usrquota'} = '';
	$mount::options{'grpquota'} = '';
	$opts = mount::join_options($type);
	@mounts = mount::list_mounts();
	for($idx=0; $idx<@mounts; $idx++) {
		last if ($mounts[$idx]->[0] eq $dir);
		}
	mount::change_mount($idx, $mounts[$idx]->[0],
				   $mounts[$idx]->[1],
				   $mounts[$idx]->[2],
				   $opts,
				   $mounts[$idx]->[4],
				   $mounts[$idx]->[5]);
	$err = mount::remount_dir($dir, $dev, $type, $opts);
	if ($err) {
		print STDERR "The filesystem $dir could not be remounted with quotas enabled. You may need to reboot your system, and then enable quotas in the Disk Quotas module.\n";
		}
	else {
		# Activate quotas
		foreign_require("quota", "quota-lib.pl");
		quota::quotaon($dir, 3);
		}
	1;
	}
	or do {
		print "Error occurred while enabling quotas on filesystems for /home: $@\n";
	};

	# iptables rules for www, smtp, ssh, ftp, domain, pop3, imap, 10000, and 20000
	eval {
  	print "Configuring firewall rules\n";
  	foreign_require("firewall", "firewall-lib.pl");
  	@tables = &firewall::get_iptables_save();
  	($filter) = grep { $_->{'name'} eq 'filter' } @tables;
  	if (!$filter) {
    	$filter = { 'name' => 'filter',
			'rules' => [ ] };
  	}
  	@tcpports = qw(ssh smtp submission domain ftp ftp-data pop3 pop3s imap imaps http https 10000 20000);
  	@udpports = qw(domain ftp ftp-data);
  	foreach ( @tcpports ) {
    	print "  Allowing traffic on TCP port: $_\n";
    	$newrule = { 'chain' => 'INPUT',
               		 'm' => [ [ '', 'tcp' ] ],
               		 'p' => [ [ '', 'tcp' ] ],
               		 'dport' => [ [ '', $_ ] ],
               		 'j' => [ [ '', 'ACCEPT' ] ],
               		};
    	splice(@{$filter->{'rules'}}, 0, 0, $newrule);
  	}
		foreach ( @udpports ) {
			print "  Allowing traffic on UDP port: $_\n";
			$newrule = { 'chain' => 'INPUT',
                'm' => [ [ '', 'udp' ] ],
                'p' => [ [ '', 'udp' ] ],
                'dport' => [ [ '', $_ ] ],
                'j' => [ [ '', 'ACCEPT' ] ],
                };
			splice(@{$filter->{'rules'}}, 0, 0, $newrule);
  	}
  	firewall::save_table($filter);
  	firewall::apply_configuration();
	1;
	}
	or do {
		print "Error occurred while configuring firewall rules: $@\n";
	};

	# Some systems have a logrotate entry for boot.log, but no such file,
	# which breaks logrotate. Fix it.
	if (!-r "/var/log/boot.log") {
		open(TOUCH, ">/var/log/boot.log");
		close(TOUCH);
	}

	# Disable CentOS 6 global AWstats cron job
	eval {
	print "Disabling default AWstats cron job\n";
	my $file = "/etc/cron.hourly/awstats";
	if (-r $file) {
		my $lref = &read_file_lines($file);
		foreach my $l (@$lref) {
			$l = "#".$l if ($l !~ /^#/);
			}
		&flush_file_lines($file);
		}
	else {
		print "None found\n";
		}
	}
	or do {
		print "Error disabling AWstats cron job: $@\n";
	};

	# Force re-detection of supported modules
	eval {
	print "Re-checking supported Webmin modules\n";
	foreign_require("webmin", "webmin-lib.pl");
	webmin::build_installed_modules(1);
	1;
	}
	or do {
		print "Error occurred while detecting supported modules: $@\n";
	};
}

# Fix up the Postfix config to use the procmail wrapper, regardless if we are
# installing or upgrading (but only if spam filtering is active)
eval {
foreign_require("postfix", "postfix-lib.pl");
$mailcmd = postfix::get_current_value("mailbox_command");
%vconfig = foreign_config("virtual-server");
if ($vconfig{'spam'} && $mailcmd =~ /procmail/ &&
    $mailcmd !~ /procmail-wrapper/) {
	postfix::set_current_value("mailbox_command",
		"/usr/bin/procmail-wrapper -o -a \$DOMAIN -d \$LOGNAME", 1);
	postfix::reload_postfix();
	}

# Turn on caching for downloads by Virtualmin
if (!$gconfig{'cache_size'}) {
	$gconfig{'cache_size'} = 50*1024*1024;
	$gconfig{'cache_mods'} = "virtual-server";
	write_file("$config_directory/config", \%gconfig);
	}
1;
}
or do {
	print "Error occurred configuration procmail delivery: $@\n";
};

%changelog
* Sat Jul 27 2013 Joe Cooper <joe@virtualmin.com>
- Re-adding support for Fedora (but not recommended for production servers).
* Sat Sep 27 2008 Joe Cooper <joe@virtualmin.com>
- One more eval...hopefully will prevent ever ending with a scriptlet failed
  error.
* Mon Mar 17 2008 Joe Cooper <joe@virtualmin.com>
- Wrap everything in eval exception blocks
* Tue Oct 17 2006 Joe Cooper <joe@virtualmin.com>
- Firewall rules configured automatically
* Wed Aug 23 2006 Joe Cooper <joe@virtualmin.com>
- procmail-wrapper broken out into independent package
- mod_fastcgi is dead, long live mod_fcgid
* Tue Aug 1 2006 Joe Cooper <joe@virtualmin.com>
- SPF records enabled in default template
* Tue Mar 28 2006 Joe Cooper <joe@virtualmin.com>
- clamd -> /usr/sbin/clamd for compatibility with Fedora Extras clamav-server package
* Thu Feb 09 2006 Joe Cooper <joe@virtualmin.com>
- postifx!=postfix
- fixed proc exec of saslauthd
* Thu Dec 08 2005 Joe Cooper <joe@virtualmin.com>
- Added dovecot and proftpd startup
- Added sasl deps and smtp auth setup
* Thu Oct 13 2005 Joe Cooper <joe@virtualmin.com>
- Fix all the stupid bugs I introduced on the 10th
- Add scponly to the Requires and add it to the /etc/shells file (TODO: chroot)
* Mon Oct 10 2005 Joe Cooper <joe@virtualmin.com>
- Remove some deps...they've gone into the virtualmin-install.sh because of
  dep resolution troubles on some systems (RHEL and SUSE)
* Thu Oct 6 2005 Joe Cooper <joe@virtualmin.com>
- Built with check for fresh install or upgrade, so we don't over-write
  users existing configuration on upgrades
* Fri Jun 17 2005 Joe Cooper <joe@virtualmin.com>
- First packaging
